#ifndef GenKill_H
#define GenKill_H

#include <iostream>
#include <limits.h>
#include "varset.h"

class GenKillNode {
	friend void GenKillNodeInit();
	public:
		GenKillNode(VarSet k, VarSet g, unsigned int c=0);      // Constructor
		~GenKillNode();

		static GenKillNode * one();
		static GenKillNode * zero();
		GenKillNode * extend( GenKillNode* ) const;
		GenKillNode * combine( GenKillNode* ) const;
        GenKillNode * quasiOne() const;
		// when is this used? for DWPDS :)
		GenKillNode * diff( GenKillNode* ) const;
		bool equal( GenKillNode* ) const;

		std::ostream& print( std::ostream& o ) const;
	private:
		VarSet kill, gen;     /* represents lambda S . (S - kill) union gen */
		static GenKillNode top,bottom,idnode;

		static GenKillNode * makeGenKillNode( VarSet& k, VarSet& g );
	public:
		unsigned int count;
		static std::ostream& print_static_nodes( std::ostream& o );
		static void init();
};

#endif
